Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | METHOD | DETAIL: FIELD | METHOD

## org.gradle.api.artifacts.maven
Interface Conf2ScopeMappingContainer

    interface Conf2ScopeMappingContainer

Defines a set of rules for how to map the Gradle dependendencies to a pom. This mapping is based on the configuration the dependencies belong to.

author:
  Hans Dockter

Field Summary
`java.lang.String` | `COMPILE`
`java.lang.String` | `PROVIDED`
`java.lang.String` | `RUNTIME`
`java.lang.String` | `TEST`

Method Summary
`Conf2ScopeMappingContainer` | `addMapping(int priority, Configuration configuration, java.lang.String scope)` Specifies that dependencies of a certain configuration should be mapped against a certain Maven scope.
`Conf2ScopeMapping` | `getMapping(Configuration configurations)` Returns a scope that corresponds to the given configurations.
`Map` | `getMappings()` Returns a map with all the configuration to scope mappings.
`boolean` | `isSkipUnmappedConfs()` Returns whether unmapped configuration should be skipped or not.
`void` | `setSkipUnmappedConfs(boolean skipDependenciesWithUnmappedConfiguration)` Sets, whether unmapped configuration should be skipped or not.

Field Detail

### COMPILE

    java.lang.String COMPILE

### PROVIDED

    java.lang.String PROVIDED

### RUNTIME

    java.lang.String RUNTIME

### TEST

    java.lang.String TEST

Method Detail

### addMapping

    public Conf2ScopeMappingContainer addMapping(int priority, Configuration configuration, java.lang.String scope)

  Specifies that dependencies of a certain configuration should be mapped against a certain Maven scope. A configuration can be mapped to one and only one scope. If this method is called more than once for a particular configuration, the last call wins.

  See #getMapping(Configuration[]) for the rules how a scope is choosen from a set of mappings.
  param:
    priority a number that is used for comparison with the priority of other scopes.
  param:
    configuration a Gradle configuration name (must not be null).
  param:
    scope A Maven scope name (must not be null)
  return:
    this
  see:
    #getMapping(Configuration[])

### getMapping

    public Conf2ScopeMapping getMapping(Configuration configurations)

  Returns a scope that corresponds to the given configurations. Dependencies of different configurations can be equal. But only one of those equals dependencies (which might differ in content) can be mapped to a pom (due to the the nature of a Maven pom).

  Which scope is returned depends on the existing mappings. See #addMapping(int, Configuration, String). If only one configuration is mapped, this mapping is used to choose the scope. If more than one configuraton of a dependency is mapped, and those mappings all map to the same scope, this scope is used. If more than one configuration is mapped and the mappings map to different scopes, the mapping with the highest priority is used. If there is more than one mapping with the highest priority and those mappings map to different scopes, an exception is thrown.

  param:
    configurations The configuration names
  return:
    The scope corresponding to the given configurations. Returns null if no such scope can be found.
  see:
    #addMapping(int, Configuration, String)

### getMappings

    public Map getMappings()

  Returns a map with all the configuration to scope mappings. If no such mapping has been defined, an empty map is returned.
  see:
    #addMapping(int, Configuration, String)

### isSkipUnmappedConfs

    public boolean isSkipUnmappedConfs()

  Returns whether unmapped configuration should be skipped or not. Defaults to true.
  see:
    #setSkipUnmappedConfs(boolean)

### setSkipUnmappedConfs

    public void setSkipUnmappedConfs(boolean skipDependenciesWithUnmappedConfiguration)

  Sets, whether unmapped configuration should be skipped or not. If this is set to false, dependencies belonging to unmapped configurations will be added to the Maven pom with no scope specified. This means they belong to the Maven default scope, which is 'compile'.

Groovy Documentation